---
apiVersion: apps/v1
kind: Deployment
metadata:
  annotations:
    reloader.stakater.com/auto: 'true'
  labels:
    app.kubernetes.io/component: recursor
    app.kubernetes.io/name: powerdns-recursor
    app.kubernetes.io/part-of: powerdns
    app.kubernetes.io/version: 5.1.2
  name: powerdns-recursor
spec:
  replicas: 3
  selector:
    matchLabels:
      app.kubernetes.io/component: recursor
      app.kubernetes.io/name: powerdns-recursor
      app.kubernetes.io/part-of: powerdns
  template:
    metadata:
      labels:
        app.kubernetes.io/component: recursor
        app.kubernetes.io/name: powerdns-recursor
        app.kubernetes.io/part-of: powerdns
    spec:
      automountServiceAccountToken: true
      containers:
        - args:
            - --api-key=$(POWERDNS_API_KEY)
            - --webserver=yes
            - --webserver-port=8080
            - --webserver-address=0.0.0.0
            - --webserver-allow-from=0.0.0.0/0
            - --serve-stale-extensions=2880
            - --export-etc-hosts=yes
          image: powerdns/pdns-recursor-51:5.1.3@sha256:8ee38dbe1d6e8b1df2d1b0ddc8af681141ea900c84f3b11e181e5fb8933972b1
          imagePullPolicy: IfNotPresent
          livenessProbe:
            failureThreshold: 3
            httpGet:
              path: /
              port: api
              scheme: HTTP
            periodSeconds: 10
            successThreshold: 1
            timeoutSeconds: 1
          name: powerdns-recursor
          ports:
            - containerPort: 53
              name: dns-udp
              protocol: UDP
            - containerPort: 53
              name: dns-tcp
              protocol: TCP
            - containerPort: 8080
              name: api
              protocol: TCP
          readinessProbe:
            failureThreshold: 3
            httpGet:
              path: /
              port: api
              scheme: HTTP
            periodSeconds: 10
            successThreshold: 1
            timeoutSeconds: 1
          resources:
            requests:
              cpu: 25m
              memory: 64Mi
            limits:
              memory: 64Mi
          securityContext:
            allowPrivilegeEscalation: false
            capabilities:
              drop:
                - ALL
            privileged: false
            readOnlyRootFilesystem: false
            runAsNonRoot: true
            runAsUser: 953
            seccompProfile:
              type: RuntimeDefault
          terminationMessagePath: /dev/termination-log
          terminationMessagePolicy: File
      dnsPolicy: ClusterFirst
      enableServiceLinks: true
      restartPolicy: Always
      schedulerName: default-scheduler
      securityContext:
        fsGroup: 953
        runAsNonRoot: true
      serviceAccountName: powerdns-recursor
      shareProcessNamespace: false
      terminationGracePeriodSeconds: 30
      affinity:
        podAntiAffinity:
          preferredDuringSchedulingIgnoredDuringExecution:
            - podAffinityTerm:
                labelSelector:
                  matchLabels:
                    app.kubernetes.io/name: powerdns-recursor
                topologyKey: kubernetes.io/hostname
              weight: 1
